package week6;



import javax.swing.JFrame;

import com.jogamp.opengl.GL;
import com.jogamp.opengl.GL2;
import com.jogamp.opengl.GLAutoDrawable;
import com.jogamp.opengl.GLCapabilities;
import com.jogamp.opengl.GLEventListener;
import com.jogamp.opengl.GLProfile;
import com.jogamp.opengl.awt.GLJPanel;
import com.jogamp.opengl.util.FPSAnimator;

/**
 * COMMENT: Comment Triangle 
 *
 * A very simple program to show how to use shaders.
 */
public class TrianglesShaders implements GLEventListener {
		
	private static final String VERTEX_SHADER = "src/week6/ConstantColorVertex.glsl";
    private static final String FRAGMENT_SHADER = "src/week6/ConstantColorFragment.glsl";
    
    private static final String VERTEX_SHADER2 = "src/week6/PassThroughVertex.glsl";
  	private static final String FRAGMENT_SHADER2 = "src/week6/PassThroughFragment.glsl";
  	
  	//private static final String VERTEX_SHADER2 = "src/week6/TestVertex.glsl";
   	//private static final String FRAGMENT_SHADER2 = "src/week6/TestFragment.glsl";
       
	private int shaderprogram;
	
	private int shaderprogram2;
	
    @Override
    public void init(GLAutoDrawable drawable) {
    	 GL2 gl = drawable.getGL().getGL2();
    	 try {
    		 shaderprogram = Shader.initShaders(gl,VERTEX_SHADER,FRAGMENT_SHADER);
    		 shaderprogram2 = Shader.initShaders(gl,VERTEX_SHADER2,FRAGMENT_SHADER2);
    		 
         }
         catch (Exception e) {
             e.printStackTrace();
             System.exit(1);
         }
    }

    @Override
    public void dispose(GLAutoDrawable drawable) {
        
    }

    @Override
    public void display(GLAutoDrawable drawable) {
    	GL2 gl = drawable.getGL().getGL2();
    	
        
        //If we turn on flat then we do not get interpolated color values.
        //gl.glShadeModel(GL2.GL_FLAT); 
       
    	
         	 
        gl.glClear(GL.GL_COLOR_BUFFER_BIT);
       
        gl.glMatrixMode(GL2.GL_MODELVIEW);
        gl.glLoadIdentity();
           
        //gl.glUseProgram(shaderprogram);
        
        gl.glBegin(GL2.GL_TRIANGLES);
        {
        	       	        	
        	gl.glColor4f(1,1,1,1);
            gl.glVertex3d(-1.5, -1,-1);
                
            gl.glColor4f(1,1,1,1);          
            gl.glVertex3d(-0.5, -1,-1);
            
            gl.glColor4f(1,1,1,1);
            gl.glVertex3d(-0.5, 1,-1);
            
        }
        gl.glEnd();
        
        
        
        //gl.glUseProgram(shaderprogram2);
        gl.glBegin(GL2.GL_TRIANGLES);
        {
        	       	        	
        	gl.glColor4f(1,0,0,1);
            gl.glVertex3d(-0.5, -1,-1);
                
            gl.glColor4f(0,1,0,1);          
            gl.glVertex3d(0.5, -1,-1);
            
            gl.glColor4f(0,0,1,1);
            gl.glVertex3d(0.5, 1,-1);
            
        }
        gl.glEnd();
        
        //Fixed Function
        //gl.glUseProgram(0);
       
        gl.glBegin(GL2.GL_TRIANGLES);
        {
        	gl.glColor4f(1,0,0,1);
            gl.glVertex3d(0.5, -1,-1);
                
            gl.glColor4f(1,1,0,1);          
            gl.glVertex3d(1.5, -1,-1);
            
            gl.glColor4f(1,1,1,1);
            gl.glVertex3d(1.5, 1,-1);
            
        }
        gl.glEnd();
          
    }

    @Override
    public void reshape(GLAutoDrawable drawable, int x, int y, int width,
            int height) {
    	GL2 gl = drawable.getGL().getGL2();
    	gl.glMatrixMode(GL2.GL_PROJECTION);
        gl.glLoadIdentity();  
    	
    	gl.glOrtho(-2, 2, -2, 2, 0.5, 5);
    }

    public static void main(String[] args) {
        
        // Initialise OpenGL
        GLProfile glp = GLProfile.getDefault();
        GLCapabilities caps = new GLCapabilities(glp);

        // Create a panel to draw on
        GLJPanel panel = new GLJPanel(caps);

        final JFrame jframe = new JFrame("Triangles");        
        jframe.setSize(300, 300);
        jframe.add(panel);
        jframe.setVisible(true);

        // Catch window closing events and quit             
        jframe.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        // add a GL Event listener to handle rendering
        TrianglesShaders triangle = new TrianglesShaders();
        panel.addGLEventListener(triangle);
        
        // NEW: add an animator to create display events at 60 FPS
        FPSAnimator animator = new FPSAnimator(60);
        animator.add(panel);
        animator.start();

    }
    
    
}
